"
 (C) 2011-2012 by Holger Hans Peter Freyther
 All Rights Reserved

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
"

Object subclass: ISUPConstants [
    <comment: 'Constants for the ISDN User Part (ISUP) protocol'>
    <category: 'OsmoNetwork-ISUP'>

    ISUPConstants class [
        msgAPT  [ <category: 'constants'> ^ 2r01000001 ] "  Application transport"
        msgACM  [ <category: 'constants'> ^ 2r00000110 ] "  Address complete"
        msgAMN  [ <category: 'constants'> ^ 2r00001001 ] "  Answer"
        msgBLA  [ <category: 'constants'> ^ 2r00010101 ] "  Blocking acknowledgement"
        msgBLO  [ <category: 'constants'> ^ 2r00010011 ] "  Blocking"
        msgCCR  [ <category: 'constants'> ^ 2r00010001 ] "  Continuity check request"
        msgCFN  [ <category: 'constants'> ^ 2r00101111 ] "  Confusion"
        msgCGB  [ <category: 'constants'> ^ 2r00011000 ] "  Circuit group blocking"
        msgCGBA [ <category: 'constants'> ^ 2r00011010 ] "  Circuit group blocking acknowledgement"
        msgCGU  [ <category: 'constants'> ^ 2r00011001 ] "  Circuit group unblocking"
        msgCGUA [ <category: 'constants'> ^ 2r00011011 ] "  Circuit group unblocking acknowledgement"
        msgCON  [ <category: 'constants'> ^ 2r00000111 ] "  Connect"
        msgCOT  [ <category: 'constants'> ^ 2r00000101 ] "  Continuity"
        msgCPG  [ <category: 'constants'> ^ 2r00101100 ] "  Call progress"
        msgCRG  [ <category: 'constants'> ^ 2r00110001 ] "  Charge information"
        msgCQM  [ <category: 'constants'> ^ 2r00101010 ] "  Circuit group query"
        msgCQR  [ <category: 'constants'> ^ 2r00101011 ] "  Circuit group query response"
        msgDRS  [ <category: 'constants'> ^ 2r00100111 ] "  Delayed release (reserved – used in 1988 version)"
        msgFAC  [ <category: 'constants'> ^ 2r00110011 ] "  Facility"
        msgFAA  [ <category: 'constants'> ^ 2r00100000 ] "  Facility accepted"
        msgFAR  [ <category: 'constants'> ^ 2r00011111 ] "  Facility request"
        msgFOT  [ <category: 'constants'> ^ 2r00001000 ] "  Forward transfer"
        msgFRJ  [ <category: 'constants'> ^ 2r00100001 ] "  Facility reject"
        msgGRA  [ <category: 'constants'> ^ 2r00101001 ] "  Circuit group reset acknowledgement"
        msgGRS  [ <category: 'constants'> ^ 2r00010111 ] "  Circuit group reset"
        msgIDR  [ <category: 'constants'> ^ 2r00110110 ] "  Identification request"
        msgIDS  [ <category: 'constants'> ^ 2r00110111 ] "  Identification response"
        msgIAM  [ <category: 'constants'> ^ 2r00000001 ] "  Initial address"
        msgINF  [ <category: 'constants'> ^ 2r00000100 ] "  Information"
        msgINR  [ <category: 'constants'> ^ 2r00000011 ] "  Information request"
        msgLPA  [ <category: 'constants'> ^ 2r00100100 ] "  Loop back acknowledgement"
        msgLPR  [ <category: 'constants'> ^ 2r01000000 ] "  Loop prevention"
        msgOLM  [ <category: 'constants'> ^ 2r00110000 ] "  Overload"
        msgPAM  [ <category: 'constants'> ^ 2r00101000 ] "  Pass-along"
        msgREL  [ <category: 'constants'> ^ 2r00001100 ] "  Release"
        msgRES  [ <category: 'constants'> ^ 2r00001110 ] "  Resume"
        msgRLC  [ <category: 'constants'> ^ 2r00010000 ] "  Release complete"
        msgRSC  [ <category: 'constants'> ^ 2r00010010 ] "  Reset circuit"
        msgSAM  [ <category: 'constants'> ^ 2r00000010 ] "  Subsequent address"
        msgSUS  [ <category: 'constants'> ^ 2r00001101 ] "  Suspend"
        msgUBL  [ <category: 'constants'> ^ 2r00010100 ] "  Unblocking"
        msgUBA  [ <category: 'constants'> ^ 2r00010110 ] "  Unblocking acknowledgement"
        msgUCIC [ <category: 'constants'> ^ 2r00101110 ] "  Unequipped circuit identification code"
        msgUSR  [ <category: 'constants'> ^ 2r00101101 ] "  User-to-user information"
        msgNRM  [ <category: 'constants'> ^ 2r00110010 ] "  Network resource management"
        msgPRI  [ <category: 'constants'> ^ 2r01000010 ] "  Pre-release information"
        msgSAN  [ <category: 'constants'> ^ 2r01000011 ] "  Subsequent Directory Number"
        msgSEG  [ <category: 'constants'> ^ 2r00111000 ] "  Segmentation"
        msgUPA  [ <category: 'constants'> ^ 2r00110100 ] "  User Part available"
        msgUPT  [ <category: 'constants'> ^ 2r00110100 ] "  User Part test"

        "TABLE C-4/Q.767" "This requires a review...."
        parAccessDeliveryInformation            [ <category: 'constants'> ^ 2r00101110 ]
        parAccessTransport                      [ <category: 'constants'> ^ 2r00000011 ]
        parApplicationTransportParameter        [ <category: 'constants'> ^ 2r01111000 ]
        parAutomaticCongestionLevel             [ <category: 'constants'> ^ 2r00100111 ]
        parBackwardCallIndicators               [ <category: 'constants'> ^ 2r00010001 ]
        parBackwardGVNS                         [ <category: 'constants'> ^ 2r01001101 ]
        parCallDiversionInformation             [ <category: 'constants'> ^ 2r00110110 ]
        parCallDiversionTreatmentIndicators     [ <category: 'constants'> ^ 2r01101110 ]
        parCallHistoryInformation               [ <category: 'constants'> ^ 2r00101101 ]
        parCallOfferingTreatmentIndicators      [ <category: 'constants'> ^ 2r01110000 ]
        parCallReference                        [ <category: 'constants'> ^ 2r00000001 ] 
        parCallTransferNumber                   [ <category: 'constants'> ^ 2r01000101 ]
        parCallTransferReference                [ <category: 'constants'> ^ 2r01000011 ]
        parCalledINNumber                       [ <category: 'constants'> ^ 2r01101111 ]
        parCalledDirectoryNumber                [ <category: 'constants'> ^ 2r01111101 ]
        parCalledPartyNumber                    [ <category: 'constants'> ^ 2r00000100 ]
        parCallingGeodeticLocation              [ <category: 'constants'> ^ 2r10000001 ]
        parCallingPartyNumber                   [ <category: 'constants'> ^ 2r00001010 ]
        parCallingPartysCategory                [ <category: 'constants'> ^ 2r00001001 ]
        parCauseIndicators                      [ <category: 'constants'> ^ 2r00010010 ]
        parCCNRPossibleIndicator                [ <category: 'constants'> ^ 2r01111010 ]
        parCCSS                                 [ <category: 'constants'> ^ 2r01001011 ]
        parChargedPartyIdentification           [ <category: 'constants'> ^ 2r01110001 ]
        parCircuitAssignmentMap                 [ <category: 'constants'> ^ 2r00100101 ]
        parCircuitGroupSupervisionMessageType   [ <category: 'constants'> ^ 2r00010101 ]
        parCircuitStateIndicator                [ <category: 'constants'> ^ 2r00100110 ]
        parClosedUserGroupInterlockCode         [ <category: 'constants'> ^ 2r00011010 ]
        parCollectCallRequest                   [ <category: 'constants'> ^ 2r01111001 ]
        parConferenceTreatmentIndicators        [ <category: 'constants'> ^ 2r01110010 ]
        parConnectedNumber                      [ <category: 'constants'> ^ 2r00100001 ]
        parConnectionRequest                    [ <category: 'constants'> ^ 2r00001101 ]
        parContinuityIndicators                 [ <category: 'constants'> ^ 2r00010000 ]
        parCorrelationId                        [ <category: 'constants'> ^ 2r01100101 ]
        parDisplayInformation                   [ <category: 'constants'> ^ 2r01110011 ]
        parEchoControlInformation               [ <category: 'constants'> ^ 2r00110111 ]
        parEndOfOptionalParameters              [ <category: 'constants'> ^ 2r00000000 ]
        parEventInformation                     [ <category: 'constants'> ^ 2r00100100 ]
        parFacilityIndicator                    [ <category: 'constants'> ^ 2r00011000 ]
        parForwardCallIndicators                [ <category: 'constants'> ^ 2r00000111 ]
        parForwardGVNS                          [ <category: 'constants'> ^ 2r01001100 ]
        parGenericDigits                        [ <category: 'constants'> ^ 2r11000001 ]
        parGenericNotificationIndicator         [ <category: 'constants'> ^ 2r00101100 ]
        parGenericNumber                        [ <category: 'constants'> ^ 2r11000000 ]
        parGenericReference                     [ <category: 'constants'> ^ 2r10000010 ]
        parHTRInformation                       [ <category: 'constants'> ^ 2r10000010 ]
        parHopCounter                           [ <category: 'constants'> ^ 2r00111101 ]
        parInformationIndicators                [ <category: 'constants'> ^ 2r00001111 ]
        parInformationRequestIndicators         [ <category: 'constants'> ^ 2r00001110 ]
        parLocationNumber                       [ <category: 'constants'> ^ 2r00111111 ]
        parLoopPreventionIndicators             [ <category: 'constants'> ^ 2r01000100 ]
        parMCIDRequestIndicators                [ <category: 'constants'> ^ 2r00111011 ]
        parMCIDResponseIndicators               [ <category: 'constants'> ^ 2r00111100 ]
        parMessageCompatibilityInformation      [ <category: 'constants'> ^ 2r00111000 ]
        parMLPPPrecedence                       [ <category: 'constants'> ^ 2r00111010 ]
        parNatureOfConnectionIndicators         [ <category: 'constants'> ^ 2r00000110 ]
        parNetworkManagementControls            [ <category: 'constants'> ^ 2r01011011 ]
        parNetworkRoutingNumber                 [ <category: 'constants'> ^ 2r10000100 ]
        parNetworkSpecificFacility              [ <category: 'constants'> ^ 2r00101111 ]
        parNumberPortabilityForwardInformation  [ <category: 'constants'> ^ 2r10001101 ]
        parOptionalBackwardCallIndicators       [ <category: 'constants'> ^ 2r00101001 ]
        parOptionalForwardCallIndicators        [ <category: 'constants'> ^ 2r00001000 ]
        parOriginalCalledNumber                 [ <category: 'constants'> ^ 2r00101000 ]
        parOriginalCalledINNumber               [ <category: 'constants'> ^ 2r01111111 ]
        parOriginationISCPointCode              [ <category: 'constants'> ^ 2r00101011 ]
        parParameterCompatibilityInformation    [ <category: 'constants'> ^ 2r00111001 ]
        parPivotCapability                      [ <category: 'constants'> ^ 2r01111011 ]
        parPivotCounter                         [ <category: 'constants'> ^ 2r10000111 ]
        parPivotRoutingBackwardInformation      [ <category: 'constants'> ^ 2r10001001 ]
        parPivotRoutingForwardInformation       [ <category: 'constants'> ^ 2r10001000 ]
        parPivotRoutingIndicators               [ <category: 'constants'> ^ 2r01111100 ]
        parPivotStatus                          [ <category: 'constants'> ^ 2r10000110 ]
        parPropagationDelayCounter              [ <category: 'constants'> ^ 2r00110001 ]
        parQoRCapability                        [ <category: 'constants'> ^ 2r10000101 ]
        parRange                                [ <category: 'constants'> ^ 2r00010110 ]
        parRangeAndStatus                       [ <category: 'constants'> ^ 2r00010110 ]
        parRedirectBackwardInformation          [ <category: 'constants'> ^ 2r10001100 ]
        parRedirectCapability                   [ <category: 'constants'> ^ 2r01001110 ]
        parRedirectCounter                      [ <category: 'constants'> ^ 2r01110111 ]
        parRedirectForwardInformation           [ <category: 'constants'> ^ 2r10001011 ]
        parRedirectStatus                       [ <category: 'constants'> ^ 2r10001010 ]
        parRedirectingNumber                    [ <category: 'constants'> ^ 2r00001011 ]
        parRedirectionInformation               [ <category: 'constants'> ^ 2r00010011 ]
        parRedirectionNumber                    [ <category: 'constants'> ^ 2r00001100 ]
        parRedirectionNumberRestriction         [ <category: 'constants'> ^ 2r01000000 ]
        parRemoteOperations                     [ <category: 'constants'> ^ 2r00110010 ]
        parSCFId                                [ <category: 'constants'> ^ 2r01100110 ]
        parServiceActivation                    [ <category: 'constants'> ^ 2r00110011 ]
        parSignallingPointCode                  [ <category: 'constants'> ^ 2r00011110 ]
        parSubsequentNumber                     [ <category: 'constants'> ^ 2r00000101 ]
        parSuspendResumeIndicators              [ <category: 'constants'> ^ 2r00100010 ]
        parTransitNetworkSelection              [ <category: 'constants'> ^ 2r00100011 ]
        parTransmissionMediumRequirement        [ <category: 'constants'> ^ 2r00000010 ]
        parTransmissionMediumRequirementPrime   [ <category: 'constants'> ^ 2r00111110 ]
        parTransmissionMediumUsed               [ <category: 'constants'> ^ 2r00110101 ]
        parUIDActionIndicators                  [ <category: 'constants'> ^ 2r01110100 ]
        parUIDCapabilityIndicators              [ <category: 'constants'> ^ 2r01110101 ]
        parUserServiceInformation               [ <category: 'constants'> ^ 2r00011101 ]
        parUserServiceInformationPrime          [ <category: 'constants'> ^ 2r00110000 ]
        parUserTeleserviceInformation           [ <category: 'constants'> ^ 2r00110100 ]
        parUserToUserIndicators                 [ <category: 'constants'> ^ 2r00101010 ]
        parUserToUserInformation                [ <category: 'constants'> ^ 2r00100000 ]

        addrNAT_NATIONAL        [ <category: 'constants'> ^ 2r0000011 ] " National (significant) number"
        addrNAT_INTERNATIONAL   [ <category: 'constants'> ^ 2r0000100 ] " International number"
    ]
]

MSGStructure subclass: ISUPMessage [
    <comment: 'I am the base class for the ISUP messages'>
    <category: 'OsmoNetwork-ISUP'>

    ISUPMessage class >> decodeByteStream: aStream [
        <category: 'parsing'>
        | col cic type |
        cic := (aStream next: 2) shortAt: 1.
        type := (aStream next: 1) at: 1.
        col := self decodeByteStream: aStream type: type.

        ^ OrderedCollection with: cic with: type with: col.
    ]

    ISUPMessage class >> encodeCollection: aCollection [
        <category: 'encoding'>
        | msg type |
        msg := Osmo.MessageBuffer new.
        type := aCollection at: 2.

        msg put16: (aCollection at: 1).
        msg putByte: type.

        msg putByteArray: (self encodeCollection: (aCollection at: 3) type: type).
        ^ msg
    ]

    parseVariable: aStream with: aClass into: decoded [
        <category: 'parsing'>
        | pos ptr res |
        pos := aStream position.
        ptr := aStream next.

        aStream skip: ptr - 1.
        res := super parseVariable: aStream with: aClass into: decoded.
        aStream position: pos + 1.

        ^ res
    ]

    prepareOptional: aStream [
        "We are done with the variable section and now get the pointer
        to the optional part and will move the stream there."
        <category: 'parsing'>
        
        | pos ptr |
        pos := aStream position.
        ptr := aStream next.
        aStream skip: ptr - 1.
    ]

    writeVariableEnd: aStream state: aState [
        <category: 'encoding'>

        "Write the optional pointer. TODO: In case of no optional this
        should be 0"
        aStream nextPut: (aState at: 'data') size + 1.
        aStream nextPutAll: (aState at: 'data') contents.
    ]

    writeVariable: msg with: clazz from: field state: aState [
        | var_len |
        "We will write a pointer and then store the data in the state"
        <category: 'encoding'>

        "Write the pointer of where the data will be"
        var_len := self variable size.
        msg nextPut: (aState at: 'data') size + var_len + 1.

        "Store the data for later"
        super writeVariable: (aState at: 'data') with: clazz from: field state: nil.
    ]

    createState [
        "Our parsing state. We need to queue the variable fields until all
        of them have been written."
        <category: 'encoding'>
        ^ Dictionary from: {'data' -> (WriteStream on: (ByteArray new: 3))}.
    ]
]

